=== docs/libflame/old/Makefile ===
pdf:
	dvipdf plapack2e.dvi plapack2e.pdf
	cp plapack2e.pdf ~/public_html/plapack2e.pdf

clean:
	rm *~; rm *.aux; rm *.idx; rm *.log; rm *.toc; rm */*~
