=== netlib-test/lapack-3.4.2/INSTALL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(TIMING Fortran)
add_executable(secondtst_NONE second_NONE.f secondtst.f)
add_executable(secondtst_EXT_ETIME second_EXT_ETIME.f secondtst.f)
add_executable(secondtst_EXT_ETIME_ second_EXT_ETIME_.f secondtst.f)
add_executable(secondtst_INT_ETIME second_INT_ETIME.f secondtst.f)
add_executable(secondtst_INT_CPU_TIME second_INT_CPU_TIME.f secondtst.f)
add_executable(testieee tstiee.f)
add_executable(testversion ilaver.f LAPACK_version.f)
