=== debian/changelog ===
libflame (5.2.0-5.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:51:55 +1100

libflame (5.2.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062315

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 12:00:57 +0000

libflame (5.2.0-5) unstable; urgency=medium

  * Amend FTBS twice in a row. (Closes: #1045506)

 -- Mo Zhou <lumin@debian.org>  Wed, 13 Sep 2023 18:20:47 -0400

libflame (5.2.0-4) unstable; urgency=medium

  * rules: fix the logic for dh_auto_test.
  * Disable autopkgtest with numpy, scipy, and octave. They are not yet
    compiled against libflame. (Closes: #1019525, #1019478, #1018074)

 -- Mo Zhou <lumin@debian.org>  Tue, 25 Oct 2022 12:39:03 -0400

libflame (5.2.0-3) unstable; urgency=medium

  * Autopkgtest: add the missing deps python3-hypothesis (Closes: #970899)

 -- Mo Zhou <lumin@debian.org>  Thu, 01 Oct 2020 15:22:19 +0800

libflame (5.2.0-2) unstable; urgency=medium

  * Upload to unstable (no change).

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jul 2020 17:00:51 +0800

libflame (5.2.0-1) experimental; urgency=medium

  * Initial release. (Closes: #945918)

 -- Mo Zhou <lumin@debian.org>  Fri, 15 May 2020 20:41:14 +0800
