=== debian/control ===
Source: libflame
Section: math
Homepage: https://github.com/flame/libflame
Priority: optional
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/libflame
Vcs-Git: https://salsa.debian.org/science-team/libflame.git
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               gfortran,
               libblas-dev | libblas.so.3,
               liblapack-dev | liblapack.so.3,
               python3-minimal

Package: libflame1t64
Provides: ${t64:Provides}
Replaces: libflame1
Breaks: libflame1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: libblas3 | libblas.so.3, ${misc:Depends}, ${shlibs:Depends}
#Provides: liblapack.so.3
Description: High-performance object-based library for DLA computations (shlib)
 libflame is a portable library for dense matrix computations, providing
 much of the functionality present in LAPACK, developed by current and
 former members of the Science of High-Performance Computing (SHPC) group
 in the Institute for Computational Engineering and Sciences at The
 University of Texas at Austin. libflame includes a compatibility layer,
 lapack2flame, which includes a complete LAPACK implementation.
 .
 This package contains the shared object.

Package: libflame-dev
Section: libdevel
Architecture: any
Depends: libflame1t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
#Provides: liblapack.so
Description: High-performance object-based library for DLA computations (dev)
 libflame is a portable library for dense matrix computations, providing
 much of the functionality present in LAPACK, developed by current and
 former members of the Science of High-Performance Computing (SHPC) group
 in the Institute for Computational Engineering and Sciences at The
 University of Texas at Austin. libflame includes a compatibility layer,
 lapack2flame, which includes a complete LAPACK implementation.
 .
 This package contains the static library and the development files.
