=== debian/tests/control ===
Tests: runtest.sh
Depends: libblas-dev, liblapack-dev, @, @builddeps@
Restrictions: allow-stderr

#Test-Command: python3 -c "import numpy as np; np.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-numpy,
#         python3-pytest,
#         python3-hypothesis,
#Restrictions: allow-stderr
#Features: test-name=numpy-with-default
#
#Test-Command: python3 -c "import scipy as sp; sp.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-pytest,
#         python3-hypothesis,
#         python3-scipy
#Restrictions: allow-stderr
#Features: test-name=scipy-with-default
#
#Test-Command: octave --eval '__run_test_suite__'
#Depends: libblas-dev, liblapack-dev, octave
#Restrictions: allow-stderr
#Features: test-name=octave-with-default
#
#Test-Command: python3 -c "import numpy as np; np.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-numpy,
#         python3-pytest,
#         python3-hypothesis,
#         @,
#         @builddeps@
#Restrictions: allow-stderr
#Features: test-name=numpy-with-libflame
#
#Test-Command: python3 -c "import scipy as sp; sp.test('full', verbose=3)"
#Depends: build-essential,
#         libblas-dev,
#         liblapack-dev,
#         python3-distutils,
#         python3-pytest,
#         python3-hypothesis,
#         python3-scipy,
#         @,
#         @builddeps@
#Restrictions: allow-stderr
#Features: test-name=scipy-with-libflame
#
#Test-Command: octave --eval '__run_test_suite__'
#Depends: libblas-dev, liblapack-dev, octave, @, @builddeps@
#Restrictions: allow-stderr
#Features: test-name=octave-with-libflame
