=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libflame-$1.tar.gz%" \
https://github.com/flame/libflame/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
